<?php
namespace BDE\BdegmbhWebservices\Internal;


class HttpHeaderAnalyseTools
{
    /**
     * @param $header
     * @return array|null
     */
    public static function analyseAccept($header)
    {
        $retval = null;

        $mimeTypes = explode(',', $header);
        $mimeTypes = array_map('trim', $mimeTypes);

        foreach ($mimeTypes as $mimeType) {
            $mimeType = explode(';', $mimeType);
            $type = array_shift($mimeType);

            if ($type) {
                list($precedence, $tokens) = self::analyseAcceptOptions($mimeType);
                $retval[] = array('type' => $type, 'precedence' => (float)$precedence, 'tokens' => $tokens);
            }
        }

        usort($toret, array('Parser', 'compare_media_ranges'));

        return $retval;
    }

    /**
     * @param $mimeType
     * @return array
     */
    public static function analyseAcceptOptions($mimeType) {
        $precedence = 1;
        $tokens = array();

        if (is_string($mimeType)) {
            $mimeType = explode(';', $mimeType);
        }

        $mimeType = array_map('trim', $mimeType);

        foreach ($mimeType as $option) {
            $option = explode('=', $option);
            $option = array_map('trim', $option);

            if ($option[0] == 'q') {
                $precedence = $option[1];
            } else {
                $tokens[$option[0]] = $option[1];
            }
        }

        $tokens = count ($tokens) ? $tokens : false;
        return array($precedence, $tokens);
    }
}